module alu (
	input [31:0] in_a,
	input [31:0] in_b,
	input alu_sel,

	input [3:0] funct3,

	output [31:0] out 
);

	reg [31:0] result;

	assign out = result;
	
	always @(*) begin
    //$display("%h %h", in_a, in_b);
    //$display("funct3: %b in_a %b", funct3, in_a);
		case (funct3)
			4'b0000:	result = (!alu_sel) ? in_a + in_b : in_a - in_b;
			4'b0001: result = in_a << in_b[4:0];
			4'b0010: result = ($signed(in_a) < $signed(in_b)) ? 1 : 0;
			4'b0011: result = (in_a < in_b) ? 1 : 0;
			4'b0100: result = in_a ^ in_b;
			4'b0101: begin
				if (!alu_sel) result = in_a >> in_b[4:0];
        else result = $signed(in_a) >>> in_b[4:0];
			end
			4'b0110: result = in_a | in_b;
			4'b0111: result = in_a & in_b;
			4'b1000: result = in_b;
		endcase
	end
endmodule
