module branch_comparator (
  input wire [31:0] rs1,
  input wire [31:0] rs2,
  input wire unsigned_comp,

  output reg branch_eq,
  output reg branch_lt
);

  always @* begin
    if (unsigned_comp) begin
      branch_eq = (rs1 == rs2) ? 1'b1 : 1'b0;
      branch_lt = (rs1 < rs2)  ? 1'b1 : 1'b0;
    end else begin
      branch_eq = ($signed(rs1) == $signed(rs2)) ? 1'b1 : 1'b0;
      branch_lt = ($signed(rs1) < $signed(rs2))  ? 1'b1 : 1'b0;
    end
  end

endmodule