`include "opcode.vh"

module gen_wr_mask (
  input [31:0] instr,
  input [31:0] addr,

  output reg [3:0] wr_mask
);

  wire [6:0] opc;
  assign opc = instr[6:0];

  wire [2:0] funct3;
  assign funct3 = instr[14:12];

  always @* begin
    // TODO: Verify is clearing the output is indeed needed
    wr_mask = 4'b0000;
    
    if (opc == `OPC_STORE) begin
      if (funct3 == 3'h0) begin // Store Byte
        case(addr[1:0])
          2'b00: wr_mask = 4'b0001;
          2'b01: wr_mask = 4'b0010;
          2'b10: wr_mask = 4'b0100;
          2'b11: wr_mask = 4'b1000;
        endcase
      end
      else if (funct3 == 3'h1) begin // Store Half
        case(addr[1:0])
          2'b00: wr_mask = 4'b0011;
          2'b10: wr_mask = 4'b1100;
        endcase
      end
      else if (funct3 == 3'h2) wr_mask = 4'b1111; // Store Word
      else wr_mask = 4'b0000;
    end
  end

endmodule
      
