#include "types.h"
#include "memory_map.h"

#define N 3
#define DIM_SIZE 10
#define EXPECTED_VALUE 2070

static int32_t Y[DIM_SIZE] = {0}; 

/* Simulates neural network matrix multiplication. 
 * Prints the sum of the entries of Y. */

#pragma GCC push_options
#pragma GCC optimize ("O0")
uint32_t matmul() {
    uint32_t sum = 0;
    uint32_t i, j;
    for (i = 0; i < DIM_SIZE; i++) {
        Y[i] = 0;
        for (j = 0; j < DIM_SIZE; j++) {
            /* Simulate weight multiplication */
            Y[i] += i * j;
        }
        /* Simulate Bias */
        Y[i] += i; 
        sum += Y[i];
    }
    return (uint32_t) sum;
}
#pragma GCC pop_options

int main(int argc, char**argv) {
    csr_tohost(0);
    /* Simulate N layers */
    uint32_t sum = 0;
    int8_t i;
    for (i = 0; i < N; i++) {
        sum = matmul();
    }
    
    if (sum == EXPECTED_VALUE) {
        csr_tohost(1);
    } else {
        csr_tohost(2);
    }
    
    // spin
    for( ; ; ) {
        asm volatile ("nop");
    }
    return 0;
}